<?php
/*
  $Id: attributeManager.php,v 3.3.4

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  based on attributeManager.php,v 1.0 21/02/06 Sam West$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Released under the GNU General Public License

  Copyright © 2006 Kangaroo Partners
  http://kangaroopartners.com
  osc@kangaroopartners.com
*/

require_once 'attributeManager/classes/amDB.class.php';
require_once 'attributeManager/includes/attributeManagerSessionFunctions.inc.php';

if ( file_exists('attributeManager/languages/' . $_SESSION['language'] . '/attributeManager.php') ) {
 include_once 'attributeManager/languages/' . $_SESSION['language'] . '/attributeManager.php';
} else {
 include_once 'attributeManager/languages/english/attributeManager.php';
}

class attributeManagerConfig {

	var $arrConfig = [];

	function __construct() {

		/**
		 * Default admin interface language id
		 */
		$this->add('AM_DEFAULT_LANGUAGE_ID', $GLOBALS['languages_id']);

		/**
		 * Default admin interface template order
		 */
		$this->add('AM_DEFAULT_TEMPLATE_ORDER', '123');

		/**
		 * Dont update the database until the end of the product addition process
		 */
		$this->add('AM_ATOMIC_PRODUCT_UPDATES', false);

		/**
		 * Use attribute templates?
		 *
		 */
		$this->add('AM_USE_TEMPLATES',true);

    /**
     * Use More Product Weight plugin? (http://addons.oscommerce.com/info/2706) (added by RusNN)
     */
    $this->add('AM_USE_MPW', false);

    /**
     * Use Options Images plugin? (https://apps.oscommerce.com/ijmp8&options-images-bs) (added by @raiwa)
     */
    $this->add('AM_USE_IMAGE', false);

    /**
		 * How do sort the drop down lists in the admin - purly asthetic
		 * options
		 * 1 = alpha
		 * 2 = default - by id
		 */
		$this->add('AM_DEFAULT_SORT_ORDER', 1);

		/**
		 * Password for the session var - doesn't matter what it is. Mix it up if you fee like it :)
		 */
		$this->add('AM_VALID_INCLUDE_PASSWORD', 'asdfjkasdadfadsff');

		/**
		 * Variable names - Shouldn't need editing unless there are conflicts
		 */
		$this->add('AM_SESSION_VAR_NAME', 'am_session_var'); // main var for atomic
		$this->add('AM_SESSION_CURRENT_LANG_VAR_NAME', 'am_current_lang_session_var'); // current interface lang
		$this->add('AM_SESSION_CURRENT_TEMPLATE_ORDER', 'am_current_template_order'); // current template order
		$this->add('AM_SESSION_VALID_INCLUDE', 'am_valid_include'); // variable set on categories.php to make sure attributeManager.php has been included
		$this->add('AM_SESSION_SORT_ORDER_INSTALL_CHECKED', 'am_sort_order_checked');
    $this->add('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED', 'am_more_product_weight_checked');
		$this->add('AM_SESSION_TEMPLATES_INSTALL_CHECKED', 'am_templates_checked');
		$this->add('AM_ACTION_GET_VARIABLE', 'amAction'); // attribute manager get variable name
		$this->add('AM_PAGE_ACTION_NAME', 'pageAction'); // attribute manager parent page action e.g. new_product

		/**
		 * Install templates if not already done so
		 */
		$this->installTemplates();

		/**
		 * Install the More Product Weight fields if they dont already exist
		 */

		$this->installMoreProductWeight();
	}

	function load() {
		if (0 !== count($this->arrConfig)) {
			foreach ($this->arrConfig as $key => $value) {
				define($key, $value);
      }
    }
	}

	function getValue($key) {
		if ( array_key_exists($key, $this->arrConfig) ) {
			return $this->arrConfig[$key];
    }
		return false;
	}

	function add($key, $value) {
		$this->arrConfig[$key] = $value;
	}

	function installTemplates() {
		if ($this->getValue('AM_USE_TEMPLATES') && !amSessionIsRegistered($this->getValue('AM_SESSION_SORT_ORDER_INSTALL_CHECKED')) && !amSessionIsRegistered($this->getValue('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED')) ) {

			tep_db_query("CREATE TABLE IF NOT EXISTS `am_templates` (
					`template_id` INT( 5 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
					`template_name` VARCHAR( 255 ) NOT NULL
				)"
			);
			tep_db_query("CREATE TABLE IF NOT EXISTS `am_attributes_to_templates` (
					`template_id` INT( 5 ) UNSIGNED NOT NULL ,
					`options_id` INT( 5 ) UNSIGNED NOT NULL ,
					`option_values_id` INT( 5 ) UNSIGNED NOT NULL ,
					`price_prefix` char(1) default '+',
					`options_values_price` decimal(15,4) default 0,
					`sort_order` int default 0,
					`option_image` varchar(127)  null default null,
          `weight_prefix` char(1) default '+',
          `options_values_weight` decimal(6,3) default '0.000',
					INDEX ( `template_id` )
				)"
			);
			// Check if the user is updating from the older version
			$install_price_prefix=true;
			$install_options_values_price=true;
      $install_more_product_weight=true;

			// Fetch database Fields
			$attributeFields = tep_db_query("SHOW COLUMNS FROM `am_attributes_to_templates`");
			while ($field = $attributeFields->fetch_assoc())  {
        $fields[] = $field['Field'];
      }

			if ( !in_array('price_prefix',$fields) ) {
				tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD(`price_prefix` char(1) default '+')");
			}
			if ( !in_array('options_values_price',$fields) ) {
				tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD(`options_values_price` decimal(15,4) default 0)");
			}
			if ( in_array('products_options_sort_order',$fields) ) {
				tep_db_query("ALTER TABLE `am_attributes_to_templates` CHANGE `products_options_sort_order` `sort_order` INT(11) NULL DEFAULT '0';");
			}
			if ( !in_array('sort_order',$fields) ) {
				tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD(`sort_order` int default 0)");
			}
      if ( !in_array('option_image',$fields) ) {
        tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD(`option_image` varchar(127)  null default null)");
      }
      if ( !in_array('weight_prefix',$fields) ) {
        tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD(`weight_prefix` char(1) default '+')");
      }
      if ( !in_array('options_values_weight',$fields) ) {
        tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD(`options_values_weight` decimal(6,3) default '0.000')");
      }

			// update products options and attributes table to Phoenix 1.0.7.10+ sort order
      if (!mysqli_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'sort_order'")) == 1 ) {
        tep_db_query("ALTER TABLE `products_attributes` ADD(`sort_order` int(3) default 0)");
      }
      if (mysqli_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'products_options_sort_order'")) == 1 ) {
        tep_db_query("UPDATE `products_attributes` SET `sort_order`=`products_options_sort_order`");
        tep_db_query("ALTER TABLE `products_attributes` DROP `products_options_sort_order`");
      }

      if (mysqli_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options' AND COLUMN_NAME LIKE 'products_options_sort_order'")) == 1 ) {
        tep_db_query("UPDATE `products_options` SET `sort_order`=`products_options_sort_order`");
        tep_db_query("ALTER TABLE `products_options` DROP `products_options_sort_order`");
      }

			// register the checked session so that this check is only done once per session
			amSessionRegister('AM_SESSION_TEMPLATES_INSTALL_CHECKED',true);

		}
	}

  function installMoreProductWeight() {
    if ( $this->getValue('AM_USE_MPW') && !amSessionIsRegistered($this->getValue('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED')) ) {
      // check that the fields are in the weights table
      $weightFields = tep_db_query("SHOW COLUMNS FROM products_attributes");
      while ($field = $weightFields->fetch_assoc()) {
        $pa_fields[] = $field['Field'];
      }
      $weightFields = tep_db_query("SHOW COLUMNS FROM orders_products_attributes");
      while ($field = $weightFields->fetch_assoc()) {
        $opa_Fields[] = $field['Field'];
      }
      $weightFields = tep_db_query("SHOW COLUMNS FROM am_attributes_to_templates");
      while ($field = $weightFields->fetch_assoc()) {
        $tmpl_Fields[] = $field['Field'];
      }
      $p_Type = '';
      $weightFields = tep_db_query("SHOW COLUMNS FROM products");
      while ($field = $weightFields->fetch_assoc()) {
        if ($field['Field'] == 'products_weight') {
          $p_Type = $field['Type'];
          break;
        }
      }

      // if not add them
      if (!in_array('weight_prefix', $pa_fields)) {
        tep_db_query("ALTER TABLE products_attributes ADD COLUMN `weight_prefix` CHAR (1) NOT NULL");
      }
      if (!in_array('options_values_weight', $pa_fields)) {
        tep_db_query("ALTER TABLE products_attributes ADD COLUMN `options_values_weight` DECIMAL (6,3) DEFAULT '0.000' NOT NULL");
      }
      if (!in_array('weight_prefix', $opa_Fields)) {
        tep_db_query("ALTER TABLE orders_products_attributes ADD COLUMN `weight_prefix` CHAR (1) NOT NULL");
      }
      if (!in_array('options_values_weight', $opa_Fields)) {
        tep_db_query("ALTER TABLE orders_products_attributes ADD COLUMN `options_values_weight` DECIMAL (6,3) DEFAULT '0.000' NOT NULL");
      }
      if (!in_array('weight_prefix', $tmpl_Fields)) {
        tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD COLUMN `weight_prefix` CHAR (1) NOT NULL default '+'");
      }
      if(!in_array('options_values_weight', $tmpl_Fields)) {
        tep_db_query("ALTER TABLE `am_attributes_to_templates` ADD COLUMN `options_values_weight` DECIMAL (6,3) DEFAULT '0.000' NOT NULL");
      }
      // change field size of product weight
      if (($p_Type != '') && ($p_Type != strtoupper('DECIMAL(6,3)'))) {
        tep_db_query("ALTER TABLE products CHANGE `products_weight` `products_weight` DECIMAL(6,3) DEFAULT '0.000' NOT NULL");
      }

      // register the checked session so that this check is only done once per session
      amSessionRegister($this->getValue('AM_SESSION_MORE_PRODUCT_WEIGHT_INSTALL_CHECKED'), true);
    }
  }

}

$config = new attributeManagerConfig();
$config->load();
