<?php
/*
  $Id: attributeManager.php, v 3.3.2

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  based on attributeManager.php,v 1.0 21/02/06 Sam West$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Released under the GNU General Public License

  Copyright © 2006 Kangaroo Partners
  http://kangaroopartners.com
  osc@kangaroopartners.com
*/

function yesNoButtons($section) {
  return '
  <div class="popupFooter">' .
    tep_draw_bootstrap_button(IMAGE_DELETE, 'fas fa-trash', null, 'primary', ['params' => 'onClick="return ' . $section . '();"'], 'btn-danger') . '&nbsp;' .
    tep_draw_bootstrap_button(IMAGE_CANCEL, 'fas fa-times', null, '', ['params' => 'onClick="removeCustomPrompt();"'], 'btn-light') .
  '</div>';
}

function updateCancelButtons($section) {
  return '
  <div class="popupFooter">' .
    tep_draw_bootstrap_button(IMAGE_SAVE, 'fas fa-save', null, 'primary', ['params' => 'onClick="return ' . $section . '();"'], 'btn-success') . '&nbsp;' .
    tep_draw_bootstrap_button(IMAGE_CANCEL, 'fas fa-times', null, '', ['params' => 'onClick="removeCustomPrompt();"'], 'btn-light') .
  '</div>';
}

function languageTextFields() {
  $return = '
  <table class="table table-sm">
    <tbody>';
	$languages = tep_get_languages();
	foreach ($languages as $amLanguage) {
  $return .='
    <tr>
      <td class="text-right">'. tep_image(DIR_WS_CATALOG . 'includes/languages/' . $amLanguage['directory'] . '/images/' . $amLanguage['image'], $amLanguage['name']).'</td>
      <td>'.tep_draw_input_field('text_field_'.$amLanguage['id'],'','id="'.$amLanguage['id'].'"').'</td>
    </tr>';
    }
  if ($_GET['section']== 'amAddOption') {
    $style = 'style="margin:3px 0px 3px 0px;" id="stockTracking_1" size="4"';
    $optionSortDrop = [['id' => '1', 'text' => '1'], ['id' => '2', 'text' => '2'], ['id' => '3', 'text' => '3'], ['id' => '4', 'text' => '4'], ['id' => '5', 'text' => '5'], ['id' => '6', 'text' => '6'], ['id' => '7', 'text' => '7'], ['id' => '8', 'text' => '8'], ['id' => '9', 'text' => '9']];
    $return .= '	<tr>';
    $return .= '<td>' . AM_AJAX_SORT . ': ' . tep_draw_pull_down_menu('optionSortDropDown', $optionSortDrop, '', 'id="optionSortDropDown"').'</td>';

    $return .= tep_draw_hidden_field('stockTracking_1', '0', $style);
    $return .='	</tr>';
  }
  $return .= '
    </tbody>
  </table>';
  return $return;
}


function okButton() {
	return '<input type="submit" align="center" value="' . AM_AJAX_OK . '" onClick="removeCustomPrompt();" />';
}

class amPopups {
	var $header = '';
	var $contents = '';

	function setHeader($string) {
		$this->header .= $string;
	}

	function addToContents($string) {
		$this->contents .= $string;
	}

	function output() {
		return '
		<div id="popupHeading">' . stripcslashes($this->header) . '</div>
		<div id="popupContainer">' . $this->contents . '</div>';
	}
}

// check that it is a prompt section
if ( isset($_GET[AM_ACTION_GET_VARIABLE]) && $_GET[AM_ACTION_GET_VARIABLE] == 'prompt' ) {

  $arrExtraValues = [];
  $valuePairs = [];

	// de encode the extra gets string
	if (isset($_GET['gets'])) {

		if (strpos($_GET['gets'], '|')) {
			$valuePairs = explode('|', $_GET['gets']);
		} else {
			$valuePairs[] = $_GET['gets'];
		}
		foreach ($valuePairs as $pair) {
			if (strpos($pair,':')) {
				list($extraKey, $extraValue) = explode(':', $pair);
				$arrExtraValues[$extraKey] = $extraValue;
			}
    }
	}

	switch($_GET['section']) {
		case 'amAddOption':
			$amPopup = new amPopups();
			$amPopup->setHeader(AM_AJAX_ENTER_NEW_OPTION_NAME);
			$amPopup->addToContents(languageTextFields());
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			echo $amPopup->output();
			break;
		case 'amAddOptionValue':
			$amPopup = new amPopups();
			$amPopup->setHeader(AM_AJAX_ENTER_NEW_OPTION_VALUE_NAME);
			$amPopup->addToContents(languageTextFields());
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			echo $amPopup->output();
			break;
		case 'amAddNewOptionValueToProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_ENTER_NEW_OPTION_VALUE_NAME_TO_ADD_TO, $arrExtraValues['option_name']));
			$amPopup->addToContents(languageTextFields());
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id',$arrExtraValues['option_id'], 'id = "option_id"'));
			echo $amPopup->output();
			break;
		case 'amRemoveOptionFromProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_REMOVE_OPTION_AND_ALL_VALUES, $arrExtraValues['option_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'], 'id = "option_id"'));
			echo $amPopup->output();
			break;
		case 'amRemoveOptionValueFromProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_REMOVE_OPTION, $arrExtraValues['option_value_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'], 'id = "option_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('option_value_id', $arrExtraValues['option_value_id'], 'id = "option_value_id"'));
			echo $amPopup->output();
			break;
//----------------------------
// Change: image attributes for AM
//
// author: @raiwa
//-----------------------------
		case 'amAddNewImageForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_IMAGE_ADD_NEW , $arrExtraValues['option_value_name']));
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_IMAGE . '</div><div class="amField">'. tep_draw_input_field('option_image', ((isset($arrExtraValues['option_image']))? $arrExtraValues['option_image'] : ''), 'id="option_image"'));
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'],'id= " option_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('option_value_id', $arrExtraValues['option_value_id'], 'id = "option_value_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('products_attributes_id',$arrExtraValues['products_attributes_id'], 'id= " products_attributes_id"'));
			echo $amPopup->output();
			break;
		case 'amDeleteImageForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_IMAGE_DELETE, $arrExtraValues['option_value_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'], 'id = "option_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('option_value_id', $arrExtraValues['option_value_id'], 'id = "option_value_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('products_attributes_id', $arrExtraValues['products_attributes_id'], 'id = "products_attributes_id"'));
			echo $amPopup->output();
			break;
//----------------------------
// EOF Change: image attributes for AM
//-----------------------------
//----------------------------
// Change: download attributes for AM
//
// author: mytool
//-----------------------------
		case 'amAddNewDownloadForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_DOWLNOAD_ADD_NEW, $arrExtraValues['option_value_name']));
			$amPopup->addToContents('<div class="amFieldset">');
			$amPopup->addToContents('<div class="amFieldLabel">' . AM_AJAX_FILENAME . '</div><div class="amField">' . tep_draw_input_field('products_attributes_filename', '', 'id = "products_attributes_filename"') );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class="amFieldset">');
			$amPopup->addToContents('<div class="amFieldLabel">' . AM_AJAX_FILE_DAYS . '</div><div class="amField">' . tep_draw_input_field('products_attributes_maxdays', '7', 'id = "products_attributes_maxdays"') . '</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class="amFieldset">');
			$amPopup->addToContents('<div class="amFieldLabel">' . AM_AJAX_FILE_COUNT . '</div><div class="amField">' . tep_draw_input_field('products_attributes_maxcount', '5', 'id = "products_attributes_maxcount"') . '</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'], 'id = "option_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('products_attributes_id', $arrExtraValues['products_attributes_id'], 'id = "products_attributes_id"'));
			echo $amPopup->output();
			break;
		case 'amEditDownloadForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_DOWLNOAD_EDIT , $arrExtraValues['option_value_name']));
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILENAME . '</div><div class = "amField">' . tep_draw_input_field('products_attributes_filename', $arrExtraValues['products_attributes_filename'], 'id = "products_attributes_filename"') );
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILE_DAYS . '</div><div class = "amField">' . tep_draw_input_field('products_attributes_maxdays', $arrExtraValues['products_attributes_maxdays'], 'id = "products_attributes_maxdays"') . '</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('<div class = "amFieldset">');
			$amPopup->addToContents('<div class = "amFieldLabel">' . AM_AJAX_FILE_COUNT . '</div><div class = "amField">' . tep_draw_input_field('products_attributes_maxcount', $arrExtraValues['products_attributes_maxcount'], 'id = "products_attributes_maxcount"') . '</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents('</div>');
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'], 'id = "option_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('products_attributes_id', $arrExtraValues['products_attributes_id'], 'id = "products_attributes_id"'));
			echo $amPopup->output();
			break;
		case 'amDeleteDownloadForProduct':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_HEADER_DOWLNOAD_DELETE, $arrExtraValues['option_value_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('option_id', $arrExtraValues['option_id'], 'id = "option_id"'));
			$amPopup->addToContents(tep_draw_hidden_field('products_attributes_id', $arrExtraValues['products_attributes_id'], 'id = "products_attributes_id"'));
			echo $amPopup->output();
			break;
//----------------------------
// EOF Change: download attributes for AM
//-----------------------------

		case 'loadTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_LOAD_TEMPLATE, $arrExtraValues['template_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('template_id', $arrExtraValues['template_id'], 'id = "template_id"'));
			echo $amPopup->output();
			break;
		case 'saveTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(AM_AJAX_NEW_TEMPLATE_NAME_HEADER);
			$amPopup->addToContents(AM_AJAX_NEW_NAME.'&nbsp'.tep_draw_input_field('template_name', '', 'id = "template_name" onchange="((this.value != \'\') ? document.getElementById(\'existing_template\').selectedIndex = 0 : \'\')"'));
			$templatesDrop = $attributeManager->buildAllTemplatesDropDown();
			$amPopup->setHeader(AM_AJAX_CHOOSE_EXISTING_TEMPLATE_TO_OVERWRITE);
			$amPopup->addToContents(AM_AJAX_CHOOSE_EXISTING_TEMPLATE_TITLE . '&nbsp' .  tep_draw_pull_down_menu('existing_template',$templatesDrop, '0', 'id = "existing_template" onChange="document.getElementById(\'template_name\').value=\'\';"'));
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('template_id', (isset($arrExtraValues['template_id'])? $arrExtraValues['template_id'] : 0 ), 'id = "template_id"'));
			echo $amPopup->output();
			break;
		case 'renameTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_RENAME_TEMPLATE_ENTER_NEW_NAME, $arrExtraValues['template_name']));
			$amPopup->addToContents(AM_AJAX_NEW_NAME.'&nbsp'.tep_draw_input_field('template_new_name', '', 'id = "template_new_name"'));
			$amPopup->addToContents(updateCancelButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('template_id', $arrExtraValues['template_id'], 'id = "template_id"'));
			echo $amPopup->output();
			break;
		case 'deleteTemplate':
			$amPopup = new amPopups();
			$amPopup->setHeader(sprintf(AM_AJAX_PROMPT_DELETE_TEMPLATE, $arrExtraValues['template_name']));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('template_id',$arrExtraValues['template_id'],'id="template_id"'));
			echo $amPopup->output();
			break;
		case 'debug':
			$amPopup = new amPopups();
			$amPopup->setHeader(implode($valuePairs, ','));
			$amPopup->addToContents(yesNoButtons(Text::prepare($_GET['section'])));
			$amPopup->addToContents(tep_draw_hidden_field('debug', $arrExtraValues['debug'], 'id = "debug"'));
			echo $amPopup->output();
			break;
	}

}
